//
// WANCableLinkConfigServerHelper.h
//
// Library: InternetGateway1
// Package: Generated
// Module:  WANCableLinkConfigServerHelper
//
// This file has been generated.
// Warning: All changes to this will be lost when the file is re-generated.
//
// Copyright (c) 2011-2012, Applied Informatics Software Engineering GmbH.
// All rights reserved.
// 
// This is unpublished proprietary source code of Applied Informatics.
// The contents of this file may not be disclosed to third parties,
// copied or duplicated in any form, in whole or in part.
// 
//


#ifndef InternetGateway1_WANCableLinkConfigServerHelper_INCLUDED
#define InternetGateway1_WANCableLinkConfigServerHelper_INCLUDED


#include "Poco/RemotingNG/Identifiable.h"
#include "Poco/RemotingNG/ORB.h"
#include "UPnPS/InternetGateway1/IWANCableLinkConfig.h"
#include "UPnPS/InternetGateway1/InternetGateway1.h"
#include "UPnPS/InternetGateway1/WANCableLinkConfig.h"
#include "UPnPS/InternetGateway1/WANCableLinkConfigRemoteObject.h"


namespace UPnPS {
namespace InternetGateway1 {


class InternetGateway1_API WANCableLinkConfigServerHelper
{
public:
private:
	WANCableLinkConfigServerHelper();
		/// Creates a WANCableLinkConfigServerHelper.

	~WANCableLinkConfigServerHelper();
		/// Destroys the WANCableLinkConfigServerHelper.

public:
	static void enableEvents(const std::string& uri, const std::string& protocol);
		/// Enables remote events for the RemoteObject identified by the given URI.
		///
		/// Events will be delivered using the Transport for the given protocol.
		/// Can be called multiple times for the same URI with different protocols.

	static std::string registerObject(Poco::SharedPtr<UPnPS::InternetGateway1::WANCableLinkConfig> pServiceObject, const Poco::RemotingNG::Identifiable::ObjectId& oid, const std::string& listenerId);
		/// Creates a RemoteObject wrapper for the given UPnPS::InternetGateway1::WANCableLinkConfig instance
		/// and registers it with the ORB and the Listener instance
		/// uniquely identified by the Listener's ID.
		/// 
		///	Returns the URI created for the object.

	static std::string registerRemoteObject(Poco::AutoPtr<UPnPS::InternetGateway1::WANCableLinkConfigRemoteObject> pRemoteObject, const std::string& listenerId);
		/// Registers the given RemoteObject with the ORB and the Listener instance
		/// uniquely identified by the Listener's ID.
		/// 
		///	Returns the URI created for the object.

	static void unregisterObject(const std::string& uri);
		/// Unregisters a service object identified by URI from the ORB.

private:
	void enableEventsImpl(const std::string& uri, const std::string& protocol);

	static WANCableLinkConfigServerHelper& instance();
		/// Returns a static instance of the helper class.

	std::string registerObjectImpl(Poco::AutoPtr<UPnPS::InternetGateway1::WANCableLinkConfigRemoteObject> pRemoteObject, const std::string& listenerId);

	void unregisterObjectImpl(const std::string& uri);

	Poco::RemotingNG::ORB* _pORB;
};


inline void WANCableLinkConfigServerHelper::enableEvents(const std::string& uri, const std::string& protocol)
{
	WANCableLinkConfigServerHelper::instance().enableEventsImpl(uri, protocol);
}


inline std::string WANCableLinkConfigServerHelper::registerObject(Poco::SharedPtr<UPnPS::InternetGateway1::WANCableLinkConfig> pServiceObject, const Poco::RemotingNG::Identifiable::ObjectId& oid, const std::string& listenerId)
{
	return WANCableLinkConfigServerHelper::instance().registerObjectImpl(new WANCableLinkConfigRemoteObject(oid, pServiceObject), listenerId);
}


inline void WANCableLinkConfigServerHelper::unregisterObject(const std::string& uri)
{
	WANCableLinkConfigServerHelper::instance().unregisterObjectImpl(uri);
}


} // namespace InternetGateway1
} // namespace UPnPS


#endif // InternetGateway1_WANCableLinkConfigServerHelper_INCLUDED

