//
// WANIPConnectionServerHelper.cpp
//
// Library: InternetGateway1
// Package: Generated
// Module:  WANIPConnectionServerHelper
//
// This file has been generated.
// Warning: All changes to this will be lost when the file is re-generated.
//
// Copyright (c) 2011-2012, Applied Informatics Software Engineering GmbH.
// All rights reserved.
// 
// This is unpublished proprietary source code of Applied Informatics.
// The contents of this file may not be disclosed to third parties,
// copied or duplicated in any form, in whole or in part.
// 
//


#include "UPnPS/InternetGateway1/WANIPConnectionServerHelper.h"
#include "Poco/RemotingNG/URIUtility.h"
#include "UPnPS/InternetGateway1/WANIPConnectionEventDispatcher.h"
#include "UPnPS/InternetGateway1/WANIPConnectionSkeleton.h"


namespace UPnPS {
namespace InternetGateway1 {


WANIPConnectionServerHelper::WANIPConnectionServerHelper():
	_pORB(0)
{
	_pORB = &Poco::RemotingNG::ORB::instance();
	_pORB->registerSkeleton("WANIPConnection", new WANIPConnectionSkeleton);
}


WANIPConnectionServerHelper::~WANIPConnectionServerHelper()
{
	_pORB->unregisterSkeleton("WANIPConnection", true);
}


std::string WANIPConnectionServerHelper::registerRemoteObject(Poco::AutoPtr<UPnPS::InternetGateway1::WANIPConnectionRemoteObject> pRemoteObject, const std::string& listenerId)
{
	return WANIPConnectionServerHelper::instance().registerObjectImpl(pRemoteObject, listenerId);
}


void WANIPConnectionServerHelper::enableEventsImpl(const std::string& uri, const std::string& protocol)
{
	Poco::RemotingNG::Identifiable::Ptr pIdentifiable = _pORB->findObject(uri);
	Poco::AutoPtr<WANIPConnectionRemoteObject> pRemoteObject = pIdentifiable.cast<WANIPConnectionRemoteObject>();
	if (pRemoteObject)
	{
		Poco::RemotingNG::EventDispatcher::Ptr pEventDispatcher = new WANIPConnectionEventDispatcher(pRemoteObject, protocol);
		_pORB->registerEventDispatcher(uri, pEventDispatcher);
	}
	else throw Poco::NotFoundException("remote object", uri);
}


WANIPConnectionServerHelper& WANIPConnectionServerHelper::instance()
{
	static WANIPConnectionServerHelper r;
	return r;
}


std::string WANIPConnectionServerHelper::registerObjectImpl(Poco::AutoPtr<UPnPS::InternetGateway1::WANIPConnectionRemoteObject> pRemoteObject, const std::string& listenerId)
{
	return _pORB->registerObject(pRemoteObject, listenerId);
}


void WANIPConnectionServerHelper::unregisterObjectImpl(const std::string& uri)
{
	_pORB->unregisterObject(uri);
}


} // namespace InternetGateway1
} // namespace UPnPS

